local frac = FRACUNIT

addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) then return end
		
		if not (p.charflags & SF_SUPER)
			p.charflags = $1|SF_SUPER
		end
		
		-- spring spin i think (used spring front flip script by Demnyx Onyxfur on mb for reference.)
		if P_PlayerInPain(p) -- can you flip or nah
		or (p.pflags & PF_JUMPED)
		or (p.pflags & PF_THOKKED)
		or (p.pflags & PF_SPINNING)
		or (mapheaderinfo[gamemap].typeoflevel == TOL_NIGHTS)
		or p.playerstate == PST_DEAD
		or p.powers[pw_carry] ~= CR_NONE
		or p.climbing >= 1
			p.canflip = false
		else
			p.canflip = true
		end
		
		if p.springflips == 1 -- if you wanna flip go ahead
			if not (p.charflags & SF_NOJUMPSPIN) -- if you cant spin you shouldnt be spinning
				if p.canflip
					if P_IsObjectOnGround(p.mo)
						p.doaflip = 0
						p.fliptime = 0
					end
					
					if p.doaflip == 1
						p.mo.state = S_PLAY_ROLL
					end
					
					if p.doaflip == 2
						if p.mo.momz < 0
							p.mo.state = S_PLAY_FALL
						elseif p.mo.momz > 0
							p.mo.state = S_PLAY_SPRING
						end
					end
					
					if p.mo.state == S_PLAY_SPRING
					and p.mo.z > p.mo.floorz + (p.mo.height*2)
						p.fliptime = $ + 1
					end
					
					if p.mo.z/frac > ((p.mo.floorz + (p.mo.height))/frac)+300
						p.doaflip = 1
					elseif p.mo.state == S_PLAY_SPRING
						p.doaflip = 0
					else
						p.doaflip = 2
					end
				end
			end
		else
			if p.canflip
				if p.mo.momz < 0
					p.mo.state = S_PLAY_FALL
				elseif p.mo.momz > 0
					p.mo.state = S_PLAY_SPRING
				end
			end
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if (p and p.mo and p.mo.valid)
		p.canflip = false
		p.doaflip = 0
		p.fliptime = 0
	end
end)

local pos = hudinfo[HUD_LIVES].y - 5
local po = hudinfo[HUD_LIVES].y 
local pox = hudinfo[HUD_LIVES].y 
local posx = hudinfo[HUD_LIVES].x - 40
hud.add(function(v, p, cam)
	if (mapheaderinfo[gamemap].typeoflevel == TOL_NIGHTS) or p.fyromentum == 0 or p.fyromentumhud == 0 then return end
	if (p and p.mo and p.mo.valid)
		v.drawFill(posx,pos - 1, p.Fboostcap/2+3, 12, 31) 
		
		if p.boostindication == 1
			v.drawFill(posx+1+(p.Fboostcap/2)/8, pos, 1, 10, skincolors[p.mo.color].ramp[3])
			v.drawFill(posx+1+(p.Fboostcap/2)/4, pos, 1, 10, skincolors[p.mo.color].ramp[3])
			v.drawFill(posx+1+(p.Fboostcap/2)/2, pos, 1, 10, skincolors[p.mo.color].ramp[3])
		end
		
		v.drawFill(posx+1,pos, p.Fboost/2+1, 10, skincolors[p.mo.color].ramp[7])
		v.drawFill(posx+1,pos, p.Fboost/2, 10, skincolors[p.mo.color].ramp[5])
		v.drawString(posx+66,pos +1,p.Fboost,YELLOWMAP,"center")
		v.drawString(posx+31,pos +1,"Boost:",YELLOWMAP,"center")
	end
end)	